#include <Graphics.hpp>
#ifndef algoritmillosH
#define algoritmillosH
const int tonoGris   = 0x00010101;//al multiplicar un entero en [0,255] obtenemos el tono gris de esa intensidad
const int filtroRojo = 0x000000FF;//al hacer un "and" bit a bit obtenemos(filtramos) slo el canal rojo
const int filtroVerde= 0x0000FF00;//al hacer un "and" bit a bit obtenemos(filtramos) slo el canal verde
const int filtroAzul = 0x00FF0000;//al hacer un "and" bit a bit obtenemos(filtramos) slo el canal azul
const int tonoRojo   = 0x00000001;//al multiplicar un entero en [0,255] obtenemos el tono rojo de esa intensidad
const int tonoVerde  = 0x00000100;//al multiplicar un entero en [0,255] obtenemos el tono verde de esa intensidad
const int tonoAzul   = 0x00010000;//al multiplicar un entero en [0,255] obtenemos el tono azul de esa intensidad
const double INFINITO=3.4E36;
void intercambiar(double **p, int i,int j)
   {
      double *temp;
      temp=p[i];//los dos de un jalon...inguesu!!
      p[i]=p[j];
      p[j]=temp;
   }

TColor gris(int c)
   {
      return (TColor)(c*tonoGris);
   }

TColor azul(int c)
   {
      return (TColor)(c*0x010000);
   }

void ordenarQS(double **p, int ref1, int ref2, int ini, int fin)//ordena puntos (orden creciente)respecto a {ref1,ref1+1,...,ref2-1,ref2}, aplicando Quick Sort
   {
      int pivote, m;//m es el lugar donde "debe quedar" el primer elemento MENOR que el pivote
      if (fin>ini+1)
         {
            pivote=(ini+fin)/2;//esto sirve si el arreglo esta "medio ordenado", como va a suceder en general...
            intercambiar(p, ini, pivote);
            pivote=ini;
            m=ini;
            for (int k=ini+1; k<=fin;k++)
               if (p[k][ref1]<p[pivote][ref1])//uno mas chico... va a ANTES que el pivote
                  {
                     intercambiar(p, k,pivote+1);//bueno!, esto podria ser mas rapido pero asi es mas elegante...y entendible
                     intercambiar(p, m,pivote+1);
                     pivote++;
                     m++;
                  }
               else if (p[k][ref1]==p[pivote][ref1])
                  {
                     intercambiar(p, k,pivote+1);
                     pivote++;//ya no hay diferencia entre el pivote original y este "pseudo-pivote"
                  }
            if (ref1<ref2)
               ordenarQS(p,ref1+1,ref2, m,pivote);
            ordenarQS(p, ref1, ref2, ini     , m-1     );
            ordenarQS(p, ref1, ref2, pivote+1, fin     );
            
         }
      else if (fin>ini)//fin==ini+1...
         if (p[fin][ref1]<p[ini][ref1])
            intercambiar(p,ini,fin);
         else if (p[fin][ref1]==p[ini][ref1])//son iguales respecto a ref1
            ordenarQS(p,ref1+1,ref2,ini,fin);


   }

void determinarCortes(double **p, int n, int **c, int *nc)
   {
      //encuentra los cortes en el arreglo de puntos p y escibe los
      //indices de corte en *c; *nc es el numero de cortes
      (*c)[0]=0;
      *nc=1;
      for (int i=0;i<n;i++)
         {
            if (p[i][0]==p[i+1][0])//"cortale mi chavo"!!
               {
                  (*c)[*nc]=i+1;
                  (*nc)++;
               }
         }
      (*c)[*nc]=n;
   }
inline double MIN(double a,double b,double c)
   {
      return a<b?(a<c?a:c):(b<c?b:c);
   }
inline double MAX(double a,double b,double c)
   {
      return a>b?(a>c?a:c):(b>c?b:c);
   }   
   
inline int MIN(int a, int b)
   {
      return (a<b)?a:b;
   }

inline int MAX(int a, int b)
   {
      return a<b?b:a;
   }

int posicion(double x, int n, double *cortes)
//regresa j si x esta en el intervalo [cortes[j], cortes[j+1]) y j+1<n;   o bien si x esta en [ cortes[n-1], infinito )
   {
      //busqueda binaria sobre el arreglo de cortes
      int inicio=0;
      int final=n-1;
      int actual=(final+inicio)/2;
      while(actual<final)
         {
            if(x<cortes[actual])
               final=actual-1;
            else if(x>cortes[actual+1])
               inicio=actual+1;
            else
               return actual;
            actual=(final+inicio)/2;
         }
      return actual;
   }   
   
#endif //algoritmillosH